/*
 * Lagerfeuer.c
 *
 * Created: 05.12.2021 18:11:23
 * Author : Chris
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include "leddrv.h"
#include "fader.h"
#include <stdlib.h>
#include <avr/wdt.h>

int main(void)
{
    wdt_enable(WDTO_1S);
    leddrv_init();
    fader_init();
    uint16_t postscale = 0;
    //pwm: ca. 469 Hz
    while (1) 
    {
        bool update = leddrv_poll();

        if(update == true)
        {
            postscale++;
            if(postscale == 1000)
            {
                //ca. 69 Hz. (nice)
                fader_tick();
                postscale = 0;
                for(uint8_t i = 0; i < 8; i++)
                {
                    if(fader_running(i) == false)
                    {
                        wdt_reset();
                        uint8_t d = rand() & 0x4F;
                        uint8_t b = rand();
                        fader_set(i, b, d);
                    }
                }
                wdt_reset();
            }
        }
    }
}
